%define kernelver 2.4.0

Summary: Kernel Module and Daemon for VPN
Name: cipe
Version: 1.4.5
Release: 6
Group: System Environment/Daemons
Source0: http://sites.inka.de/sites/bigred/sw/cipe-%{version}.tar.gz
Source1: ifup-cipcb
Source2: ifdown-cipcb
Source3: findroute.c
Source4: cipe-example-options
Source5: cipe-example-ifcfg
Patch0: cipe-1.3.0.patch
Patch1: cipe-1.4.5-userlandonly.patch
Patch2: cipe-1.4.5-time.patch
Patch3: cipe-1.4.6-dir.patch
Patch4: cipe-1.4.5-64bit.patch
BuildRoot: %{_tmppath}/%{name}-root
URL: http://sites.inka.de/~W1011/devel/cipe.html
License: GPL
Prereq: /sbin/install-info

%description
CIPE (the name is shortened from Crypto IP Encapsulation) is a
package for an encrypting IP tunnel device. This can be used to build
encrypting routers for VPN (Virtual Private Networks) and similar
applications.

%prep
%setup -q -n cipe-%{version}
%patch0 -p0
%patch1 -p1 -b .userland
%patch2 -p1 -b .time
%patch3 -p1
%patch4 -p0
autoconf -l conf

%build
autoconf --localdir=conf
%configure
make -C obj version.h all
gcc -o findroute $RPM_SOURCE_DIR/findroute.c

%install
%makeinstall INFODIR=$RPM_BUILD_ROOT%{_infodir} \
		BINDIR=$RPM_BUILD_ROOT%{_sbindir} \
		RPM_BUILD_ROOT=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/{cipe,sysconfig/network-scripts}
mkdir -p $RPM_BUILD_ROOT/sbin

install -m 755 samples/ip-up   $RPM_BUILD_ROOT/etc/cipe/ip-up
install -m 755 samples/ip-down $RPM_BUILD_ROOT/etc/cipe/ip-down
install -m 755 $RPM_SOURCE_DIR/ifup-cipcb $RPM_BUILD_ROOT/etc/sysconfig/network-scripts/ifup-cipcb
install -m 755 $RPM_SOURCE_DIR/ifdown-cipcb $RPM_BUILD_ROOT/etc/sysconfig/network-scripts/ifdown-cipcb
install -m 755 findroute $RPM_BUILD_ROOT/sbin/findroute
cp $RPM_SOURCE_DIR/cipe-example-options samples/redhat-options.cipcb0
cp $RPM_SOURCE_DIR/cipe-example-ifcfg samples/redhat-ifcfg-cipcb0

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc CHANGES COPYING README README.key-bug samples
%{_infodir}/cipe*
%{_sbindir}/ciped-cb
#/sbin/findroute
%config /etc/sysconfig/network-scripts/ifup-cipcb
%config /etc/sysconfig/network-scripts/ifdown-cipcb
%config(noreplace) /etc/cipe

%post
/sbin/install-info %{_infodir}/cipe.info.gz %{_infodir}/dir

%preun
if [ $1 = 0 ]; then
    /sbin/install-info --delete %{_infodir}/cipe.info.gz %{_infodir}/dir
fi

# trigger to remove init script symlinks from old broken cipe packages
%triggerun -- cipe < 1.4.5-4
[ -x /sbin/chkconfig ] && /sbin/chkconfig --del cipe > /dev/null 2>&1 || exit 0

%changelog
* Wed May 09 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- add a 64 bit patch

* Thu Mar  1 2001 Matt Wilson <msw@redhat.com>
- updated cipe-example-ifcfg (redhat-ifcfg-cipcb0) to reflect the needed
  PEER info and that MYPORT doesn't set both endpoints.

* Fri Feb 23 2001 Matt Wilson <msw@redhat.com>
- added a triggerun on cipe < 1.4.5 to remove old init scripts (#28668)

* Wed Feb 21 2001 Nalin Dahyabhai <nalin@redhat.com>
- install and uninstall the info docs at install and uninstall time (#28425)

* Wed Feb 14 2001 Matt Wilson <msw@redhat.com>
- make version.h explicitly, fix time.h include

* Thu Jan 18 2001 Matt Wilson <msw@redhat.com>
- patched so we don't need kernel headers to build this userland bit

* Thu Dec 14 2000 Matt Wilson <msw@redhat.com>
- decided that the findroute stuff wasn't really needed anyway.

* Fri Oct  6 2000 Matt Wilson <msw@redhat.com>
- nuked braindamaged initscript for cipe
- added interface starter/stopper that integrates with Red Hat's
  networking setup
- wrote a quick program to walk a box's routing table to find the
  interface you can talk to the peer on if you don't bind me to an ip
- you can now place config options in /etc/cipe/options.cipcb0 for the
  key, etc (where cipcb0 goes to N devices)
- you can set ME, MYPORT, PEER, IPADDR, PTPADDR in
  /etc/sysconfig/network-scripts/ifcfg-cipcb0 - you could also put
  them in the options file instead.
- if you leave ME out of the options file and ifcfg file, the
  interface that will be used to get to the peer is automatically
  passed as 'me'
- now control starting and stopping cipe devices with "ifup cipcb0"
  and "ifdown cipcb0", including the ability to make it a user
  controlled interface
- if you need other interfaces to come up before the cipe interface,
  use "ONBOOT=no" in ifcfg-cipcb0 and make the ifup-local script start
  the cipe interface when the interface you need to get to the peer is
  started

* Wed Aug 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- mark it as a snapshot because 1.4 is actually out now

* Thu Aug 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- change version number to 1.4 (it's a 1.4 snapshot) (#15943)
- fix erroneous comments in /etc/sysconfig/cipe (#16148)
- configure with --with-linux=/lib/modules/`uname -r`/build if it exists
- add URL: tag
- change Copyright: to License:

* Wed Aug  9 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix init script

* Mon Aug  7 2000 Nalin Dahyabhai <nalin@redhat.com>
- add IPADDR and PTPADDR options to the sysconfig file (#14956)

* Sun Jul 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- make configurations noreplace
- supply a default /etc/sysconfig/cipe file (#14467)
- tweak the init script some more (#14468)

* Sat Jul 15 2000 Bill Nottingham <notting@redhat.com>
- move initscript back

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Tue Jul 11 2000 Matt Wilson <msw@redhat.com>
- move group from Applications/Networking to System Environment/Daemons

* Mon Jul 10 2000 Trond Eivind Glomsrd <teg@redhat.com>
- obvious bandaid1: add the sysconfig file it tries to source
- obvious bandaid2: remove the "su to specific user and run his
  specific program on another computer"-part of the initscript
- Prereq: /etc/init.d

* Sun Jul  2 2000 Florian La Roche <Florian.LaRoche@redhat.com>
- first version of a rpm based on an RH-internal rpm
- TODO: /etc/init.d/ciped must be fixed
